#ifndef KMLGenerator_helper_h
#define KMLGenerator_helper_h

#include <stdint.h>

typedef struct time {
    uint_fast8_t hour, minute, second;
    uint_fast16_t millisecond;
}nmea_Time;

typedef struct date {
    uint_fast8_t day, month, year;
}nmea_Date;

typedef struct nmea_gga_dataset {
    nmea_Time time;
    double latitude;
    char lat_direction;
    double longitude;
    char lon_direction;
    uint_fast8_t fix, sattelites;
    float hdop, altitude, wgs84_altitude;
    char altitude_unit, wgs84_altitude_unit;
    float dgps_age;
    uint_fast16_t dgps_id;
}nmea_GGA, *nmea_GGA_p;

typedef struct nmea_gsa_dataset{
    uint_fast8_t fix;
    uint_fast8_t prn_nr[12];
    float pdop, hdop, vdop;
}nmea_GSA, *nmea_GSA_p;

typedef struct nmea_rmc_dataset {
    nmea_Time time;
    char state;
    double latitude;
    char lat_direction;
    double longitude;
    char lon_direction;
    float speed, course;
    nmea_Date date;
    float variation;
    char var_direction;
}nmea_RMC, *nmea_RMC_p;

typedef struct nmea_vtg_dataset{
    float mag_course, course, speed, speed_metric;
}nmea_VTG, *nmea_VTG_p;

typedef struct gps_dataset {
    nmea_GGA_p gga;
    nmea_GSA_p gsa;
    nmea_RMC_p rmc;
    nmea_VTG_p vtg;
}nmea_GPS_dataset, *nmea_GPS_dataset_p;

#endif
